#!/usr/bin/python2.7

import rospy
import numpy as np
import cv2
from sensor_msgs.msg import CompressedImage
from cv_bridge import CvBridge

bridge = CvBridge()

def img_callback(msg):
    img = bridge.compressed_imgmsg_to_cv2(msg, 'bgr8')
    hsv = cv2.cvtColor(img, cv2.COLOR_BGR2HSV)

    lower_yellow = np.array([20, 100, 100])
    upper_yellow = np.array([30, 255, 255])

    mask = cv2.inRange(hsv, lower_yellow, upper_yellow)

    cv2.imshow('Yellow detected', mask)
    cv2.waitKey(3)

if __name__ == '__main__':
	img_topic = '/raspicam_node/image/compressed'

	rospy.init_node('imv_view')
	rospy.Subscriber(img_topic, CompressedImage, img_callback)
	rospy.spin()
